//
// File: My2Cego.cc
// This code was produced by the dragon parser generator
//
#include "My2Cego.h"
#include <lfcbase/Exception.h>
#include <lfcbase/StackT.h>

My2Cego::ScannerStateEntry::ScannerStateEntry()
{
}

My2Cego::ScannerStateEntry::ScannerStateEntry(int state, ScannerStateType type)
{
   _state = state;
   _type = type;
}

My2Cego::ScannerStateEntry& My2Cego::ScannerStateEntry::operator = (const My2Cego::ScannerStateEntry& s)
{
   _state = s._state;
   _type = s._type;
   return(*this);
}

bool My2Cego::ScannerStateEntry::operator == (const My2Cego::ScannerStateEntry& s)
{
   if ( _state == s._state )
      return true;
   return false;
}

My2Cego::ScannerStateType My2Cego::ScannerStateEntry::getType()
{
   return _type;
}
int My2Cego::ScannerStateEntry::getState()
{
   return _state;
}


My2Cego::ScannerTransEntry::ScannerTransEntry()
{
}

My2Cego::ScannerTransEntry::ScannerTransEntry(int state, char c)
{
   _state = state;
   _c = c;
}

My2Cego::ScannerTransEntry::ScannerTransEntry(int state, char c, int fstate)
{
   _state = state;
   _c = c;
   _fstate = fstate;
}

My2Cego::ScannerTransEntry& My2Cego::ScannerTransEntry::operator = (const My2Cego::ScannerTransEntry& s)
{
   _state = s._state;
   _c = s._c;
   _fstate = s._fstate;
   return(*this);
}

bool My2Cego::ScannerTransEntry::operator == (const My2Cego::ScannerTransEntry& s)
{
   if ( _state == s._state && _c == s._c)
      return true;
   return false;
}

int My2Cego::ScannerTransEntry::getFState()
{
   return _fstate;
}


My2Cego::Scanner::Scanner()
{
}


My2Cego::Scanner::Scanner(Token t)
{
   _token = t;
}

My2Cego::Token My2Cego::Scanner::getToken()
{
   return _token;
}

void My2Cego::Scanner::addState(ScannerStateEntry s)
{
   _stateList.Insert(s);
}

void My2Cego::Scanner::addTransition(ScannerTransEntry t)
{
   _transList.Insert(t);
}

bool My2Cego::Scanner::checkPattern(const Chain& p)
{
   unsigned long state = 0;
   ScannerStateEntry* pS = _stateList.First();
   while (pS)
   {
      if (pS->getType() == START || pS->getType() == ANY)
      {
         state = pS->getState();
         pS = 0;
      }
      else
      {
         pS = _stateList.Next();
      }
   }
   unsigned long i = 0;
   ScannerTransEntry* pT = 
   _transList.Find(ScannerTransEntry(state, p[i]));
   while (pT)
   {
      ScannerStateEntry* pS = _stateList.Find(ScannerStateEntry(pT->getFState())); 
      if (pS)
      {
         if ( ( i == p.length()-2 ) && ( pS->getType() == FINAL || pS->getType() == ANY))
         {
            return true;
         }
         else
         {
            state = pT->getFState();
         }
      }
      else
      {
         return false;
      }
      i++;
      pT = _transList.Find(ScannerTransEntry(state, p[i]));
   }
   return false;
}
My2Cego::StackEntry::StackEntry()
{
   _symbol = NONE;
}

My2Cego::StackEntry::StackEntry(Symbol symbol, int num, int state, Chain tval)
{
   _symbol=symbol;
   _num=num;
   _state=state;
   _tval=tval;
}

My2Cego::StackEntry& My2Cego::StackEntry::operator = (const My2Cego::StackEntry& se)
{
   _symbol=se._symbol;
   _num=se._num;
   _state=se._state;
   _tval=se._tval;
   return(*this);
}

int My2Cego::StackEntry::getState()
{
   return _state;
}
My2Cego::Symbol My2Cego::StackEntry::getSymbol()
{
   return _symbol;
}
Chain& My2Cego::StackEntry::getTval()
{
   return _tval;
}

My2Cego::ActionEntry::ActionEntry()
{
   _action=NULLACTION;
}

My2Cego::ActionEntry::ActionEntry(Action action , int num)
{
   _action=action;
   _num=num;
}

bool My2Cego::ActionEntry::operator == (const My2Cego::ActionEntry& ae)
{
   if (_action == ae._action && _num == ae._num)
      return true;
   return false;
}

My2Cego::ActionEntry& My2Cego::ActionEntry::operator = (const My2Cego::ActionEntry& ae)
{
   _action=ae._action;
   _num=ae._num;
   return(*this);
}

My2Cego::Action My2Cego::ActionEntry::getAction()
{
   return _action;
}

int My2Cego::ActionEntry::getNum()
{
   return _num;
}

My2Cego::ProdEntry::ProdEntry()
{
}

My2Cego::ProdEntry::ProdEntry(int id)
{
   _id = id;
}

My2Cego::ProdEntry::ProdEntry(int id, Production prod, int numSymbol)
{
   _id = id;
   _prod = prod;
   _numSymbol = numSymbol;
}

bool My2Cego::ProdEntry::operator == (const My2Cego::ProdEntry& pe)
{
   if (_id == pe._id)
      return true;
   return false;
}

My2Cego::ProdEntry& My2Cego::ProdEntry::operator = (const My2Cego::ProdEntry& pe)
{
   _id = pe._id;
   _prod = pe._prod;
   _numSymbol = pe._numSymbol;
   return(*this);
}


int My2Cego::ProdEntry::getId()
{
   return _id;
}

My2Cego::Production My2Cego::ProdEntry::getProd()
{
   return _prod;
}

int My2Cego::ProdEntry::getNumSymbol()
{
   return _numSymbol;
}
void My2Cego::loadScanner()
{
   Scanner s0(AUTOINCREMENT);
   s0.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(2 ,START));
   s0.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(9 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(10 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(11 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(12 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(13 ,INTERMEDIATE));
   s0.addState(ScannerStateEntry(14 ,FINAL));
   s0.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s0.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s0.addTransition(ScannerTransEntry(2 ,'a' ,0));
   s0.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s0.addTransition(ScannerTransEntry(4 ,'_' ,5));
   s0.addTransition(ScannerTransEntry(5 ,'i' ,6));
   s0.addTransition(ScannerTransEntry(6 ,'n' ,7));
   s0.addTransition(ScannerTransEntry(7 ,'c' ,8));
   s0.addTransition(ScannerTransEntry(8 ,'r' ,9));
   s0.addTransition(ScannerTransEntry(9 ,'e' ,10));
   s0.addTransition(ScannerTransEntry(10 ,'m' ,11));
   s0.addTransition(ScannerTransEntry(11 ,'e' ,12));
   s0.addTransition(ScannerTransEntry(12 ,'n' ,13));
   s0.addTransition(ScannerTransEntry(13 ,'t' ,14));
   _scannerList.Insert(s0);

   Scanner s1(BOOL);
   s1.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(2 ,START));
   s1.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s1.addState(ScannerStateEntry(4 ,FINAL));
   s1.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s1.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s1.addTransition(ScannerTransEntry(2 ,'b' ,0));
   s1.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s1);

   Scanner s2(CHARSET);
   s2.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(2 ,START));
   s2.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s2.addState(ScannerStateEntry(7 ,FINAL));
   s2.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s2.addTransition(ScannerTransEntry(1 ,'a' ,3));
   s2.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s2.addTransition(ScannerTransEntry(3 ,'r' ,4));
   s2.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s2.addTransition(ScannerTransEntry(5 ,'e' ,6));
   s2.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s2);

   Scanner s3(CREATE);
   s3.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(2 ,START));
   s3.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s3.addState(ScannerStateEntry(6 ,FINAL));
   s3.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s3.addTransition(ScannerTransEntry(1 ,'e' ,3));
   s3.addTransition(ScannerTransEntry(2 ,'c' ,0));
   s3.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s3.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s3.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s3);

   Scanner s4(DEFAULT);
   s4.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(2 ,START));
   s4.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s4.addState(ScannerStateEntry(7 ,FINAL));
   s4.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s4.addTransition(ScannerTransEntry(1 ,'f' ,3));
   s4.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s4.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s4.addTransition(ScannerTransEntry(4 ,'u' ,5));
   s4.addTransition(ScannerTransEntry(5 ,'l' ,6));
   s4.addTransition(ScannerTransEntry(6 ,'t' ,7));
   _scannerList.Insert(s4);

   Scanner s5(DOUBLE);
   s5.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(2 ,START));
   s5.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s5.addState(ScannerStateEntry(6 ,FINAL));
   s5.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s5.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s5.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s5.addTransition(ScannerTransEntry(3 ,'b' ,4));
   s5.addTransition(ScannerTransEntry(4 ,'l' ,5));
   s5.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s5);

   Scanner s6(DROP);
   s6.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(2 ,START));
   s6.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s6.addState(ScannerStateEntry(4 ,FINAL));
   s6.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s6.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s6.addTransition(ScannerTransEntry(2 ,'d' ,0));
   s6.addTransition(ScannerTransEntry(3 ,'p' ,4));
   _scannerList.Insert(s6);

   Scanner s7(ENUM);
   s7.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(2 ,START));
   s7.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s7.addState(ScannerStateEntry(4 ,FINAL));
   s7.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s7.addTransition(ScannerTransEntry(1 ,'u' ,3));
   s7.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s7.addTransition(ScannerTransEntry(3 ,'m' ,4));
   _scannerList.Insert(s7);

   Scanner s8(ENGINE);
   s8.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(2 ,START));
   s8.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s8.addState(ScannerStateEntry(6 ,FINAL));
   s8.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s8.addTransition(ScannerTransEntry(1 ,'g' ,3));
   s8.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s8.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s8.addTransition(ScannerTransEntry(4 ,'n' ,5));
   s8.addTransition(ScannerTransEntry(5 ,'e' ,6));
   _scannerList.Insert(s8);

   Scanner s9(EXISTS);
   s9.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(2 ,START));
   s9.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s9.addState(ScannerStateEntry(6 ,FINAL));
   s9.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s9.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s9.addTransition(ScannerTransEntry(2 ,'e' ,0));
   s9.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s9.addTransition(ScannerTransEntry(4 ,'t' ,5));
   s9.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s9);

   Scanner s10(FALSEVAL);
   s10.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(2 ,START));
   s10.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s10.addState(ScannerStateEntry(5 ,FINAL));
   s10.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s10.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s10.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s10.addTransition(ScannerTransEntry(3 ,'s' ,4));
   s10.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s10);

   Scanner s11(FLOAT);
   s11.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(2 ,START));
   s11.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s11.addState(ScannerStateEntry(5 ,FINAL));
   s11.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s11.addTransition(ScannerTransEntry(1 ,'o' ,3));
   s11.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s11.addTransition(ScannerTransEntry(3 ,'a' ,4));
   s11.addTransition(ScannerTransEntry(4 ,'t' ,5));
   _scannerList.Insert(s11);

   Scanner s12(FOREIGN);
   s12.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(2 ,START));
   s12.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s12.addState(ScannerStateEntry(7 ,FINAL));
   s12.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s12.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s12.addTransition(ScannerTransEntry(2 ,'f' ,0));
   s12.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s12.addTransition(ScannerTransEntry(4 ,'i' ,5));
   s12.addTransition(ScannerTransEntry(5 ,'g' ,6));
   s12.addTransition(ScannerTransEntry(6 ,'n' ,7));
   _scannerList.Insert(s12);

   Scanner s13(IF);
   s13.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s13.addState(ScannerStateEntry(1 ,FINAL));
   s13.addState(ScannerStateEntry(2 ,START));
   s13.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s13.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s13);

   Scanner s14(INDEX);
   s14.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(2 ,START));
   s14.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s14.addState(ScannerStateEntry(5 ,FINAL));
   s14.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s14.addTransition(ScannerTransEntry(1 ,'d' ,3));
   s14.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s14.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s14.addTransition(ScannerTransEntry(4 ,'x' ,5));
   _scannerList.Insert(s14);

   Scanner s15(INT);
   s15.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s15.addState(ScannerStateEntry(2 ,START));
   s15.addState(ScannerStateEntry(3 ,FINAL));
   s15.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s15.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s15.addTransition(ScannerTransEntry(2 ,'i' ,0));
   _scannerList.Insert(s15);

   Scanner s16(INTO);
   s16.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(2 ,START));
   s16.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s16.addState(ScannerStateEntry(4 ,FINAL));
   s16.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s16.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s16.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s16.addTransition(ScannerTransEntry(3 ,'o' ,4));
   _scannerList.Insert(s16);

   Scanner s17(INSERT);
   s17.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(2 ,START));
   s17.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s17.addState(ScannerStateEntry(6 ,FINAL));
   s17.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s17.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s17.addTransition(ScannerTransEntry(2 ,'i' ,0));
   s17.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s17.addTransition(ScannerTransEntry(4 ,'r' ,5));
   s17.addTransition(ScannerTransEntry(5 ,'t' ,6));
   _scannerList.Insert(s17);

   Scanner s18(KEY);
   s18.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s18.addState(ScannerStateEntry(2 ,START));
   s18.addState(ScannerStateEntry(3 ,FINAL));
   s18.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s18.addTransition(ScannerTransEntry(1 ,'y' ,3));
   s18.addTransition(ScannerTransEntry(2 ,'k' ,0));
   _scannerList.Insert(s18);

   Scanner s19(LOCK);
   s19.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(2 ,START));
   s19.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s19.addState(ScannerStateEntry(4 ,FINAL));
   s19.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s19.addTransition(ScannerTransEntry(1 ,'c' ,3));
   s19.addTransition(ScannerTransEntry(2 ,'l' ,0));
   s19.addTransition(ScannerTransEntry(3 ,'k' ,4));
   _scannerList.Insert(s19);

   Scanner s20(NOT);
   s20.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s20.addState(ScannerStateEntry(2 ,START));
   s20.addState(ScannerStateEntry(3 ,FINAL));
   s20.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s20.addTransition(ScannerTransEntry(1 ,'t' ,3));
   s20.addTransition(ScannerTransEntry(2 ,'n' ,0));
   _scannerList.Insert(s20);

   Scanner s21(NULLTOKEN);
   s21.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(2 ,START));
   s21.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s21.addState(ScannerStateEntry(4 ,FINAL));
   s21.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s21.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s21.addTransition(ScannerTransEntry(2 ,'n' ,0));
   s21.addTransition(ScannerTransEntry(3 ,'l' ,4));
   _scannerList.Insert(s21);

   Scanner s22(PRIMARY);
   s22.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(2 ,START));
   s22.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s22.addState(ScannerStateEntry(7 ,FINAL));
   s22.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s22.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s22.addTransition(ScannerTransEntry(2 ,'p' ,0));
   s22.addTransition(ScannerTransEntry(3 ,'m' ,4));
   s22.addTransition(ScannerTransEntry(4 ,'a' ,5));
   s22.addTransition(ScannerTransEntry(5 ,'r' ,6));
   s22.addTransition(ScannerTransEntry(6 ,'y' ,7));
   _scannerList.Insert(s22);

   Scanner s23(TABLE);
   s23.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(2 ,START));
   s23.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s23.addState(ScannerStateEntry(5 ,FINAL));
   s23.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s23.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s23.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s23.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s23.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s23);

   Scanner s24(TABLES);
   s24.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(2 ,START));
   s24.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s24.addState(ScannerStateEntry(6 ,FINAL));
   s24.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s24.addTransition(ScannerTransEntry(1 ,'b' ,3));
   s24.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s24.addTransition(ScannerTransEntry(3 ,'l' ,4));
   s24.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s24.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s24);

   Scanner s25(TIMESTAMP);
   s25.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(2 ,START));
   s25.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(8 ,INTERMEDIATE));
   s25.addState(ScannerStateEntry(9 ,FINAL));
   s25.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s25.addTransition(ScannerTransEntry(1 ,'m' ,3));
   s25.addTransition(ScannerTransEntry(2 ,'t' ,0));
   s25.addTransition(ScannerTransEntry(3 ,'e' ,4));
   s25.addTransition(ScannerTransEntry(4 ,'s' ,5));
   s25.addTransition(ScannerTransEntry(5 ,'t' ,6));
   s25.addTransition(ScannerTransEntry(6 ,'a' ,7));
   s25.addTransition(ScannerTransEntry(7 ,'m' ,8));
   s25.addTransition(ScannerTransEntry(8 ,'p' ,9));
   _scannerList.Insert(s25);

   Scanner s26(UNLOCK);
   s26.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(2 ,START));
   s26.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s26.addState(ScannerStateEntry(6 ,FINAL));
   s26.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s26.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s26.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s26.addTransition(ScannerTransEntry(3 ,'o' ,4));
   s26.addTransition(ScannerTransEntry(4 ,'c' ,5));
   s26.addTransition(ScannerTransEntry(5 ,'k' ,6));
   _scannerList.Insert(s26);

   Scanner s27(UNSIGNED);
   s27.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(2 ,START));
   s27.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(7 ,INTERMEDIATE));
   s27.addState(ScannerStateEntry(8 ,FINAL));
   s27.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s27.addTransition(ScannerTransEntry(1 ,'s' ,3));
   s27.addTransition(ScannerTransEntry(2 ,'u' ,0));
   s27.addTransition(ScannerTransEntry(3 ,'i' ,4));
   s27.addTransition(ScannerTransEntry(4 ,'g' ,5));
   s27.addTransition(ScannerTransEntry(5 ,'n' ,6));
   s27.addTransition(ScannerTransEntry(6 ,'e' ,7));
   s27.addTransition(ScannerTransEntry(7 ,'d' ,8));
   _scannerList.Insert(s27);

   Scanner s28(VALUES);
   s28.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(2 ,START));
   s28.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s28.addState(ScannerStateEntry(6 ,FINAL));
   s28.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s28.addTransition(ScannerTransEntry(1 ,'l' ,3));
   s28.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s28.addTransition(ScannerTransEntry(3 ,'u' ,4));
   s28.addTransition(ScannerTransEntry(4 ,'e' ,5));
   s28.addTransition(ScannerTransEntry(5 ,'s' ,6));
   _scannerList.Insert(s28);

   Scanner s29(VARCHAR);
   s29.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(2 ,START));
   s29.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(5 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(6 ,INTERMEDIATE));
   s29.addState(ScannerStateEntry(7 ,FINAL));
   s29.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s29.addTransition(ScannerTransEntry(1 ,'r' ,3));
   s29.addTransition(ScannerTransEntry(2 ,'v' ,0));
   s29.addTransition(ScannerTransEntry(3 ,'c' ,4));
   s29.addTransition(ScannerTransEntry(4 ,'h' ,5));
   s29.addTransition(ScannerTransEntry(5 ,'a' ,6));
   s29.addTransition(ScannerTransEntry(6 ,'r' ,7));
   _scannerList.Insert(s29);

   Scanner s30(WRITE);
   s30.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(2 ,START));
   s30.addState(ScannerStateEntry(3 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(4 ,INTERMEDIATE));
   s30.addState(ScannerStateEntry(5 ,FINAL));
   s30.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s30.addTransition(ScannerTransEntry(1 ,'i' ,3));
   s30.addTransition(ScannerTransEntry(2 ,'w' ,0));
   s30.addTransition(ScannerTransEntry(3 ,'t' ,4));
   s30.addTransition(ScannerTransEntry(4 ,'e' ,5));
   _scannerList.Insert(s30);

   Scanner s31(MINUS);
   s31.addState(ScannerStateEntry(0 ,START));
   s31.addState(ScannerStateEntry(1 ,FINAL));
   s31.addTransition(ScannerTransEntry(0 ,'-' ,1));
   _scannerList.Insert(s31);

   Scanner s32(EQU);
   s32.addState(ScannerStateEntry(0 ,START));
   s32.addState(ScannerStateEntry(1 ,FINAL));
   s32.addTransition(ScannerTransEntry(0 ,'=' ,1));
   _scannerList.Insert(s32);

   Scanner s33(KSEP);
   s33.addState(ScannerStateEntry(0 ,START));
   s33.addState(ScannerStateEntry(1 ,FINAL));
   s33.addTransition(ScannerTransEntry(0 ,',' ,1));
   _scannerList.Insert(s33);

   Scanner s34(LB);
   s34.addState(ScannerStateEntry(0 ,START));
   s34.addState(ScannerStateEntry(1 ,FINAL));
   s34.addTransition(ScannerTransEntry(0 ,'(' ,1));
   _scannerList.Insert(s34);

   Scanner s35(RB);
   s35.addState(ScannerStateEntry(0 ,START));
   s35.addState(ScannerStateEntry(1 ,FINAL));
   s35.addTransition(ScannerTransEntry(0 ,')' ,1));
   _scannerList.Insert(s35);

   Scanner s36(SEMICOLON);
   s36.addState(ScannerStateEntry(0 ,START));
   s36.addState(ScannerStateEntry(1 ,FINAL));
   s36.addTransition(ScannerTransEntry(0 ,';' ,1));
   _scannerList.Insert(s36);

   Scanner s37(INTVAL);
   s37.addState(ScannerStateEntry(0 ,START));
   s37.addState(ScannerStateEntry(1 ,FINAL));
   s37.addState(ScannerStateEntry(2 ,FINAL));
   s37.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s37.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s37.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s37.addTransition(ScannerTransEntry(1 ,'9' ,1));
   _scannerList.Insert(s37);

   Scanner s38(FLOATVAL);
   s38.addState(ScannerStateEntry(0 ,START));
   s38.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(2 ,INTERMEDIATE));
   s38.addState(ScannerStateEntry(3 ,FINAL));
   s38.addTransition(ScannerTransEntry(0 ,'1' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'2' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'3' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'4' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'5' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'6' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'7' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'8' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'9' ,1));
   s38.addTransition(ScannerTransEntry(0 ,'0' ,2));
   s38.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s38.addTransition(ScannerTransEntry(1 ,'.' ,3));
   s38.addTransition(ScannerTransEntry(2 ,'.' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'0' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'1' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'2' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'3' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'4' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'5' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'6' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'7' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'8' ,3));
   s38.addTransition(ScannerTransEntry(3 ,'9' ,3));
   _scannerList.Insert(s38);

   Scanner s39(QIDENTIFIER);
   s39.addState(ScannerStateEntry(0 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(1 ,INTERMEDIATE));
   s39.addState(ScannerStateEntry(2 ,START));
   s39.addState(ScannerStateEntry(3 ,FINAL));
   s39.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s39.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'z' ,1));
   s39.addTransition(ScannerTransEntry(1 ,'`' ,3));
   s39.addTransition(ScannerTransEntry(2 ,'`' ,0));
   _scannerList.Insert(s39);

   Scanner s40(IDENTIFIER);
   s40.addState(ScannerStateEntry(0 ,START));
   s40.addState(ScannerStateEntry(1 ,FINAL));
   s40.addTransition(ScannerTransEntry(0 ,'$' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'A' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'B' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'C' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'D' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'E' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'F' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'G' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'H' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'I' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'J' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'K' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'L' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'M' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'N' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'O' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'P' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'Q' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'R' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'S' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'T' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'U' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'V' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'W' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'X' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'Y' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'Z' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'a' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'b' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'c' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'d' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'e' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'f' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'g' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'h' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'i' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'j' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'k' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'l' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'m' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'n' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'o' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'p' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'q' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'r' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'s' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'t' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'u' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'v' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'w' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'x' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'y' ,1));
   s40.addTransition(ScannerTransEntry(0 ,'z' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'0' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'1' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'2' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'3' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'4' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'5' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'6' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'7' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'8' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'9' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'A' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'B' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'C' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'D' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'E' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'F' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'G' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'H' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'I' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'J' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'K' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'L' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'M' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'N' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'O' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'P' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'Q' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'R' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'S' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'T' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'U' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'V' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'W' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'X' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'Y' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'Z' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'_' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'a' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'b' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'c' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'d' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'e' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'f' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'g' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'h' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'i' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'j' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'k' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'l' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'m' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'n' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'o' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'p' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'q' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'r' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'s' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'t' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'u' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'v' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'w' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'x' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'y' ,1));
   s40.addTransition(ScannerTransEntry(1 ,'z' ,1));
   _scannerList.Insert(s40);

}
void My2Cego::loadParser0()
{
   _actionMap[100][SEMICOLON] = ActionEntry(REDUCE, 15);
   _actionMap[101][KSEP] = ActionEntry(REDUCE, 30);
   _actionMap[101][RB] = ActionEntry(REDUCE, 30);
   _actionMap[102][KSEP] = ActionEntry(REDUCE, 45);
   _actionMap[102][RB] = ActionEntry(REDUCE, 45);
   _actionMap[88][DEFAULT] = ActionEntry(REDUCE, 13);
   _actionMap[88][SEMICOLON] = ActionEntry(REDUCE, 13);
   _actionMap[89][IDENTIFIER] = ActionEntry(SHIFT, 100);
   _actionMap[90][AUTOINCREMENT] = ActionEntry(REDUCE, 11);
   _actionMap[90][DEFAULT] = ActionEntry(REDUCE, 11);
   _actionMap[90][SEMICOLON] = ActionEntry(REDUCE, 11);
   _actionMap[91][QIDENTIFIER] = ActionEntry(SHIFT, 101);
   _actionMap[92][KSEP] = ActionEntry(REDUCE, 29);
   _actionMap[92][RB] = ActionEntry(REDUCE, 29);
   _actionMap[93][KSEP] = ActionEntry(REDUCE, 19);
   _actionMap[93][RB] = ActionEntry(REDUCE, 19);
   _actionMap[94][KSEP] = ActionEntry(REDUCE, 27);
   _actionMap[94][RB] = ActionEntry(REDUCE, 27);
   _actionMap[95][AUTOINCREMENT] = ActionEntry(REDUCE, 24);
   _actionMap[95][RB] = ActionEntry(REDUCE, 24);
   _actionMap[95][KSEP] = ActionEntry(REDUCE, 24);
   _actionMap[96][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[96][MINUS] = ActionEntry(SHIFT, 50);
   _actionMap[96][STRINGVAL] = ActionEntry(SHIFT, 48);
   _actionMap[96][NULLTOKEN] = ActionEntry(SHIFT, 49);
   _jumpMap[96][Constant] = 102;
   _actionMap[97][NULLTOKEN] = ActionEntry(REDUCE, 44);
   _actionMap[97][NOT] = ActionEntry(REDUCE, 44);
   _actionMap[97][DEFAULT] = ActionEntry(REDUCE, 44);
   _actionMap[97][AUTOINCREMENT] = ActionEntry(REDUCE, 44);
   _actionMap[97][RB] = ActionEntry(REDUCE, 44);
   _actionMap[97][KSEP] = ActionEntry(REDUCE, 44);
   _actionMap[98][UNSIGNED] = ActionEntry(REDUCE, 51);
   _actionMap[98][NULLTOKEN] = ActionEntry(REDUCE, 51);
   _actionMap[98][NOT] = ActionEntry(REDUCE, 51);
   _actionMap[98][DEFAULT] = ActionEntry(REDUCE, 51);
   _actionMap[98][AUTOINCREMENT] = ActionEntry(REDUCE, 51);
   _actionMap[98][RB] = ActionEntry(REDUCE, 51);
   _actionMap[98][KSEP] = ActionEntry(REDUCE, 51);
   _actionMap[99][NULLTOKEN] = ActionEntry(REDUCE, 42);
   _actionMap[99][NOT] = ActionEntry(REDUCE, 42);
   _actionMap[99][DEFAULT] = ActionEntry(REDUCE, 42);
   _actionMap[99][AUTOINCREMENT] = ActionEntry(REDUCE, 42);
   _actionMap[99][RB] = ActionEntry(REDUCE, 42);
   _actionMap[99][KSEP] = ActionEntry(REDUCE, 42);
   _actionMap[72][INTVAL] = ActionEntry(SHIFT, 88);
   _actionMap[73][EQU] = ActionEntry(SHIFT, 89);
   _actionMap[74][IDENTIFIER] = ActionEntry(SHIFT, 90);
   _actionMap[75][RB] = ActionEntry(SHIFT, 92);
   _actionMap[75][KSEP] = ActionEntry(SHIFT, 91);
}
void My2Cego::loadParser1()
{
   _actionMap[76][KSEP] = ActionEntry(REDUCE, 31);
   _actionMap[76][RB] = ActionEntry(REDUCE, 31);
   _actionMap[77][AUTOINCREMENT] = ActionEntry(SHIFT, 94);
   _actionMap[77][KSEP] = ActionEntry(REDUCE, 28);
   _actionMap[77][RB] = ActionEntry(REDUCE, 28);
   _jumpMap[77][IncrementOpt] = 93;
   _actionMap[78][AUTOINCREMENT] = ActionEntry(REDUCE, 25);
   _actionMap[78][RB] = ActionEntry(REDUCE, 25);
   _actionMap[78][KSEP] = ActionEntry(REDUCE, 25);
   _actionMap[79][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[79][MINUS] = ActionEntry(SHIFT, 50);
   _actionMap[79][STRINGVAL] = ActionEntry(SHIFT, 48);
   _actionMap[79][NULLTOKEN] = ActionEntry(SHIFT, 49);
   _jumpMap[79][Constant] = 95;
   _actionMap[80][DEFAULT] = ActionEntry(REDUCE, 21);
   _actionMap[80][AUTOINCREMENT] = ActionEntry(REDUCE, 21);
   _actionMap[80][RB] = ActionEntry(REDUCE, 21);
   _actionMap[80][KSEP] = ActionEntry(REDUCE, 21);
   _actionMap[81][RB] = ActionEntry(SHIFT, 97);
   _actionMap[81][KSEP] = ActionEntry(SHIFT, 96);
   _actionMap[82][KSEP] = ActionEntry(REDUCE, 46);
   _actionMap[82][RB] = ActionEntry(REDUCE, 46);
   _actionMap[83][NULLTOKEN] = ActionEntry(REDUCE, 41);
   _actionMap[83][NOT] = ActionEntry(REDUCE, 41);
   _actionMap[83][DEFAULT] = ActionEntry(REDUCE, 41);
   _actionMap[83][AUTOINCREMENT] = ActionEntry(REDUCE, 41);
   _actionMap[83][RB] = ActionEntry(REDUCE, 41);
   _actionMap[83][KSEP] = ActionEntry(REDUCE, 41);
   _actionMap[84][NULLTOKEN] = ActionEntry(REDUCE, 52);
   _actionMap[84][NOT] = ActionEntry(REDUCE, 52);
   _actionMap[84][DEFAULT] = ActionEntry(REDUCE, 52);
   _actionMap[84][AUTOINCREMENT] = ActionEntry(REDUCE, 52);
   _actionMap[84][RB] = ActionEntry(REDUCE, 52);
   _actionMap[84][KSEP] = ActionEntry(REDUCE, 52);
   _actionMap[85][RB] = ActionEntry(SHIFT, 98);
   _actionMap[86][RB] = ActionEntry(SHIFT, 99);
   _actionMap[87][KSEP] = ActionEntry(REDUCE, 38);
   _actionMap[87][RB] = ActionEntry(REDUCE, 38);
   _actionMap[52][KSEP] = ActionEntry(REDUCE, 17);
   _actionMap[52][RB] = ActionEntry(REDUCE, 17);
   _actionMap[53][AUTOINCREMENT] = ActionEntry(SHIFT, 56);
   _actionMap[53][DEFAULT] = ActionEntry(REDUCE, 14);
   _actionMap[53][SEMICOLON] = ActionEntry(REDUCE, 14);
   _jumpMap[53][CharsetOpt] = 55;
   _jumpMap[53][AutoIncrementOpt] = 54;
   _actionMap[54][DEFAULT] = ActionEntry(SHIFT, 57);
   _actionMap[54][SEMICOLON] = ActionEntry(REDUCE, 16);
   _jumpMap[54][CharsetOpt] = 55;
   _actionMap[55][SEMICOLON] = ActionEntry(REDUCE, 7);
   _actionMap[56][EQU] = ActionEntry(SHIFT, 72);
}
void My2Cego::loadParser2()
{
   _actionMap[57][CHARSET] = ActionEntry(SHIFT, 73);
   _actionMap[58][EQU] = ActionEntry(SHIFT, 74);
   _actionMap[59][QIDENTIFIER] = ActionEntry(SHIFT, 76);
   _jumpMap[59][KeyList] = 75;
   _actionMap[60][KSEP] = ActionEntry(REDUCE, 26);
   _actionMap[60][RB] = ActionEntry(REDUCE, 26);
   _actionMap[60][AUTOINCREMENT] = ActionEntry(REDUCE, 26);
   _actionMap[60][DEFAULT] = ActionEntry(SHIFT, 79);
   _jumpMap[60][DefaultDefOpt] = 78;
   _jumpMap[60][DefaultOpt] = 77;
   _actionMap[61][DEFAULT] = ActionEntry(REDUCE, 22);
   _actionMap[61][AUTOINCREMENT] = ActionEntry(REDUCE, 22);
   _actionMap[61][RB] = ActionEntry(REDUCE, 22);
   _actionMap[61][KSEP] = ActionEntry(REDUCE, 22);
   _actionMap[62][NULLTOKEN] = ActionEntry(SHIFT, 80);
   _actionMap[63][DEFAULT] = ActionEntry(REDUCE, 20);
   _actionMap[63][AUTOINCREMENT] = ActionEntry(REDUCE, 20);
   _actionMap[63][RB] = ActionEntry(REDUCE, 20);
   _actionMap[63][KSEP] = ActionEntry(REDUCE, 20);
   _actionMap[64][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[64][MINUS] = ActionEntry(SHIFT, 50);
   _actionMap[64][STRINGVAL] = ActionEntry(SHIFT, 48);
   _actionMap[64][NULLTOKEN] = ActionEntry(SHIFT, 49);
   _jumpMap[64][Constant] = 82;
   _jumpMap[64][ConstList] = 81;
   _actionMap[65][UNSIGNED] = ActionEntry(SHIFT, 84);
   _actionMap[65][NULLTOKEN] = ActionEntry(REDUCE, 53);
   _actionMap[65][NOT] = ActionEntry(REDUCE, 53);
   _actionMap[65][DEFAULT] = ActionEntry(REDUCE, 53);
   _actionMap[65][AUTOINCREMENT] = ActionEntry(REDUCE, 53);
   _actionMap[65][RB] = ActionEntry(REDUCE, 53);
   _actionMap[65][KSEP] = ActionEntry(REDUCE, 53);
   _jumpMap[65][UnsignedOpt] = 83;
   _actionMap[66][INTVAL] = ActionEntry(SHIFT, 85);
   _actionMap[67][INTVAL] = ActionEntry(SHIFT, 86);
   _actionMap[68][SEMICOLON] = ActionEntry(REDUCE, 35);
   _actionMap[68][KSEP] = ActionEntry(REDUCE, 35);
   _actionMap[69][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[69][MINUS] = ActionEntry(SHIFT, 50);
   _actionMap[69][STRINGVAL] = ActionEntry(SHIFT, 48);
   _actionMap[69][NULLTOKEN] = ActionEntry(SHIFT, 49);
   _jumpMap[69][Constant] = 87;
   _actionMap[70][SEMICOLON] = ActionEntry(REDUCE, 37);
   _actionMap[70][KSEP] = ActionEntry(REDUCE, 37);
   _actionMap[71][AUTOINCREMENT] = ActionEntry(REDUCE, 48);
   _actionMap[71][RB] = ActionEntry(REDUCE, 48);
   _actionMap[71][KSEP] = ActionEntry(REDUCE, 48);
   _actionMap[37][QIDENTIFIER] = ActionEntry(SHIFT, 33);
   _actionMap[37][PRIMARY] = ActionEntry(SHIFT, 32);
   _jumpMap[37][ColumnDesc] = 52;
}
void My2Cego::loadParser3()
{
   _actionMap[38][ENGINE] = ActionEntry(SHIFT, 58);
   _actionMap[38][AUTOINCREMENT] = ActionEntry(REDUCE, 12);
   _actionMap[38][DEFAULT] = ActionEntry(REDUCE, 12);
   _actionMap[38][SEMICOLON] = ActionEntry(REDUCE, 12);
   _jumpMap[38][CharsetOpt] = 55;
   _jumpMap[38][AutoIncrementOpt] = 54;
   _jumpMap[38][EngineOpt] = 53;
   _actionMap[39][LB] = ActionEntry(SHIFT, 59);
   _actionMap[40][KSEP] = ActionEntry(REDUCE, 23);
   _actionMap[40][RB] = ActionEntry(REDUCE, 23);
   _actionMap[40][AUTOINCREMENT] = ActionEntry(REDUCE, 23);
   _actionMap[40][DEFAULT] = ActionEntry(REDUCE, 23);
   _actionMap[40][NULLTOKEN] = ActionEntry(SHIFT, 63);
   _actionMap[40][NOT] = ActionEntry(SHIFT, 62);
   _jumpMap[40][DefaultNullOpt] = 61;
   _jumpMap[40][NullOpt] = 60;
   _actionMap[41][LB] = ActionEntry(SHIFT, 64);
   _actionMap[42][LB] = ActionEntry(SHIFT, 66);
   _jumpMap[42][DimOpt] = 65;
   _actionMap[43][NULLTOKEN] = ActionEntry(REDUCE, 43);
   _actionMap[43][NOT] = ActionEntry(REDUCE, 43);
   _actionMap[43][DEFAULT] = ActionEntry(REDUCE, 43);
   _actionMap[43][AUTOINCREMENT] = ActionEntry(REDUCE, 43);
   _actionMap[43][RB] = ActionEntry(REDUCE, 43);
   _actionMap[43][KSEP] = ActionEntry(REDUCE, 43);
   _actionMap[44][LB] = ActionEntry(SHIFT, 67);
   _actionMap[45][LB] = ActionEntry(SHIFT, 36);
   _jumpMap[45][InsertValueSpec] = 68;
   _actionMap[46][RB] = ActionEntry(SHIFT, 70);
   _actionMap[46][KSEP] = ActionEntry(SHIFT, 69);
   _actionMap[47][KSEP] = ActionEntry(REDUCE, 39);
   _actionMap[47][RB] = ActionEntry(REDUCE, 39);
   _actionMap[48][AUTOINCREMENT] = ActionEntry(REDUCE, 49);
   _actionMap[48][KSEP] = ActionEntry(REDUCE, 49);
   _actionMap[48][RB] = ActionEntry(REDUCE, 49);
   _actionMap[49][AUTOINCREMENT] = ActionEntry(REDUCE, 50);
   _actionMap[49][RB] = ActionEntry(REDUCE, 50);
   _actionMap[49][KSEP] = ActionEntry(REDUCE, 50);
   _actionMap[50][INTVAL] = ActionEntry(SHIFT, 71);
   _actionMap[51][AUTOINCREMENT] = ActionEntry(REDUCE, 47);
   _actionMap[51][KSEP] = ActionEntry(REDUCE, 47);
   _actionMap[51][RB] = ActionEntry(REDUCE, 47);
   _actionMap[30][RB] = ActionEntry(SHIFT, 38);
   _actionMap[30][KSEP] = ActionEntry(SHIFT, 37);
   _actionMap[31][KSEP] = ActionEntry(REDUCE, 18);
   _actionMap[31][RB] = ActionEntry(REDUCE, 18);
   _actionMap[32][KEY] = ActionEntry(SHIFT, 39);
   _actionMap[33][INT] = ActionEntry(SHIFT, 42);
   _actionMap[33][VARCHAR] = ActionEntry(SHIFT, 44);
   _actionMap[33][TIMESTAMP] = ActionEntry(SHIFT, 43);
}
void My2Cego::loadParser4()
{
   _actionMap[33][ENUM] = ActionEntry(SHIFT, 41);
   _jumpMap[33][DataTypeProd] = 40;
   _actionMap[34][KSEP] = ActionEntry(SHIFT, 45);
   _actionMap[34][SEMICOLON] = ActionEntry(REDUCE, 34);
   _actionMap[35][SEMICOLON] = ActionEntry(REDUCE, 36);
   _actionMap[35][KSEP] = ActionEntry(REDUCE, 36);
   _actionMap[36][INTVAL] = ActionEntry(SHIFT, 51);
   _actionMap[36][MINUS] = ActionEntry(SHIFT, 50);
   _actionMap[36][STRINGVAL] = ActionEntry(SHIFT, 48);
   _actionMap[36][NULLTOKEN] = ActionEntry(SHIFT, 49);
   _jumpMap[36][Constant] = 47;
   _jumpMap[36][InsertValueList] = 46;
   _actionMap[26][QIDENTIFIER] = ActionEntry(SHIFT, 33);
   _actionMap[26][PRIMARY] = ActionEntry(SHIFT, 32);
   _jumpMap[26][ColumnDesc] = 31;
   _jumpMap[26][ColumnList] = 30;
   _actionMap[27][QIDENTIFIER] = ActionEntry(REDUCE, 10);
   _actionMap[28][LB] = ActionEntry(SHIFT, 36);
   _jumpMap[28][InsertValueSpec] = 35;
   _jumpMap[28][InsertValueSpecList] = 34;
   _actionMap[29][SEMICOLON] = ActionEntry(REDUCE, 32);
   _actionMap[21][SEMICOLON] = ActionEntry(REDUCE, 1);
   _actionMap[21][CREATE] = ActionEntry(REDUCE, 1);
   _actionMap[21][DROP] = ActionEntry(REDUCE, 1);
   _actionMap[21][UNLOCK] = ActionEntry(REDUCE, 1);
   _actionMap[21][LOCK] = ActionEntry(REDUCE, 1);
   _actionMap[21][INSERT] = ActionEntry(REDUCE, 1);
   _actionMap[21][ENDTOKEN] = ActionEntry(REDUCE, 1);
   _actionMap[22][LB] = ActionEntry(SHIFT, 26);
   _actionMap[23][EXISTS] = ActionEntry(SHIFT, 27);
   _actionMap[24][VALUES] = ActionEntry(SHIFT, 28);
   _actionMap[25][WRITE] = ActionEntry(SHIFT, 29);
   _actionMap[12][SEMICOLON] = ActionEntry(SHIFT, 21);
   _actionMap[13][SEMICOLON] = ActionEntry(REDUCE, 2);
   _actionMap[13][CREATE] = ActionEntry(REDUCE, 2);
   _actionMap[13][DROP] = ActionEntry(REDUCE, 2);
   _actionMap[13][UNLOCK] = ActionEntry(REDUCE, 2);
   _actionMap[13][LOCK] = ActionEntry(REDUCE, 2);
   _actionMap[13][INSERT] = ActionEntry(REDUCE, 2);
   _actionMap[13][ENDTOKEN] = ActionEntry(REDUCE, 2);
   _actionMap[14][SEMICOLON] = ActionEntry(REDUCE, 8);
   _actionMap[15][SEMICOLON] = ActionEntry(REDUCE, 40);
   _actionMap[15][VALUES] = ActionEntry(REDUCE, 40);
   _actionMap[15][LB] = ActionEntry(REDUCE, 40);
   _actionMap[16][QIDENTIFIER] = ActionEntry(SHIFT, 15);
   _jumpMap[16][Table] = 22;
   _actionMap[17][IF] = ActionEntry(SHIFT, 23);
   _actionMap[17][QIDENTIFIER] = ActionEntry(REDUCE, 9);
   _actionMap[18][QIDENTIFIER] = ActionEntry(SHIFT, 15);
   _jumpMap[18][Table] = 24;
}
void My2Cego::loadParser5()
{
   _actionMap[19][QIDENTIFIER] = ActionEntry(SHIFT, 25);
   _actionMap[20][SEMICOLON] = ActionEntry(REDUCE, 33);
   _actionMap[1][ENDTOKEN] = ActionEntry(ACCEPT, 0);
   _actionMap[1][DROP] = ActionEntry(SHIFT, 8);
   _actionMap[1][UNLOCK] = ActionEntry(SHIFT, 11);
   _actionMap[1][LOCK] = ActionEntry(SHIFT, 10);
   _actionMap[1][INSERT] = ActionEntry(SHIFT, 9);
   _actionMap[1][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[1][CREATE] = ActionEntry(SHIFT, 7);
   _jumpMap[1][InsertStatement] = 6;
   _jumpMap[1][UnlockStatement] = 5;
   _jumpMap[1][LockStatement] = 4;
   _jumpMap[1][DropOpt] = 3;
   _jumpMap[1][Statement] = 12;
   _actionMap[2][SEMICOLON] = ActionEntry(SHIFT, 13);
   _actionMap[3][QIDENTIFIER] = ActionEntry(SHIFT, 15);
   _jumpMap[3][Table] = 14;
   _actionMap[4][SEMICOLON] = ActionEntry(REDUCE, 5);
   _actionMap[5][SEMICOLON] = ActionEntry(REDUCE, 6);
   _actionMap[6][SEMICOLON] = ActionEntry(REDUCE, 4);
   _actionMap[7][TABLE] = ActionEntry(SHIFT, 16);
   _actionMap[8][TABLE] = ActionEntry(SHIFT, 17);
   _actionMap[9][INTO] = ActionEntry(SHIFT, 18);
   _actionMap[10][TABLES] = ActionEntry(SHIFT, 19);
   _actionMap[11][TABLES] = ActionEntry(SHIFT, 20);
   _actionMap[0][DROP] = ActionEntry(SHIFT, 8);
   _actionMap[0][UNLOCK] = ActionEntry(SHIFT, 11);
   _actionMap[0][LOCK] = ActionEntry(SHIFT, 10);
   _actionMap[0][INSERT] = ActionEntry(SHIFT, 9);
   _actionMap[0][SEMICOLON] = ActionEntry(REDUCE, 3);
   _actionMap[0][CREATE] = ActionEntry(SHIFT, 7);
   _jumpMap[0][InsertStatement] = 6;
   _jumpMap[0][UnlockStatement] = 5;
   _jumpMap[0][LockStatement] = 4;
   _jumpMap[0][DropOpt] = 3;
   _jumpMap[0][Statement] = 2;
   _jumpMap[0][StatementList] = 1;
}
void My2Cego::loadParser6()
{
   _prodInfo.Insert(ProdEntry(53, UnsignedOpt, 0));
   _prodInfo.Insert(ProdEntry(52, UnsignedOpt, 1));
   _prodInfo.Insert(ProdEntry(51, DimOpt, 3));
   _prodInfo.Insert(ProdEntry(50, Constant, 1));
   _prodInfo.Insert(ProdEntry(49, Constant, 1));
   _prodInfo.Insert(ProdEntry(48, Constant, 2));
   _prodInfo.Insert(ProdEntry(47, Constant, 1));
   _prodInfo.Insert(ProdEntry(46, ConstList, 1));
   _prodInfo.Insert(ProdEntry(45, ConstList, 3));
   _prodInfo.Insert(ProdEntry(44, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(43, DataTypeProd, 1));
   _prodInfo.Insert(ProdEntry(42, DataTypeProd, 4));
   _prodInfo.Insert(ProdEntry(41, DataTypeProd, 3));
   _prodInfo.Insert(ProdEntry(40, Table, 1));
   _prodInfo.Insert(ProdEntry(39, InsertValueList, 1));
   _prodInfo.Insert(ProdEntry(38, InsertValueList, 3));
   _prodInfo.Insert(ProdEntry(37, InsertValueSpec, 3));
   _prodInfo.Insert(ProdEntry(36, InsertValueSpecList, 1));
   _prodInfo.Insert(ProdEntry(35, InsertValueSpecList, 3));
   _prodInfo.Insert(ProdEntry(34, InsertStatement, 5));
   _prodInfo.Insert(ProdEntry(33, UnlockStatement, 2));
   _prodInfo.Insert(ProdEntry(32, LockStatement, 4));
   _prodInfo.Insert(ProdEntry(31, KeyList, 1));
   _prodInfo.Insert(ProdEntry(30, KeyList, 3));
   _prodInfo.Insert(ProdEntry(29, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(28, IncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(27, IncrementOpt, 1));
   _prodInfo.Insert(ProdEntry(26, DefaultDefOpt, 0));
   _prodInfo.Insert(ProdEntry(25, DefaultOpt, 1));
   _prodInfo.Insert(ProdEntry(24, DefaultOpt, 2));
   _prodInfo.Insert(ProdEntry(23, DefaultNullOpt, 0));
   _prodInfo.Insert(ProdEntry(22, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(21, NullOpt, 2));
   _prodInfo.Insert(ProdEntry(20, NullOpt, 1));
   _prodInfo.Insert(ProdEntry(19, ColumnDesc, 5));
   _prodInfo.Insert(ProdEntry(18, ColumnList, 1));
   _prodInfo.Insert(ProdEntry(17, ColumnList, 3));
   _prodInfo.Insert(ProdEntry(16, CharsetOpt, 0));
   _prodInfo.Insert(ProdEntry(15, CharsetOpt, 4));
   _prodInfo.Insert(ProdEntry(14, AutoIncrementOpt, 0));
   _prodInfo.Insert(ProdEntry(13, AutoIncrementOpt, 3));
   _prodInfo.Insert(ProdEntry(12, EngineOpt, 0));
   _prodInfo.Insert(ProdEntry(11, EngineOpt, 3));
   _prodInfo.Insert(ProdEntry(10, DropOpt, 4));
   _prodInfo.Insert(ProdEntry(9, DropOpt, 2));
   _prodInfo.Insert(ProdEntry(8, Statement, 2));
   _prodInfo.Insert(ProdEntry(7, Statement, 9));
   _prodInfo.Insert(ProdEntry(6, Statement, 1));
   _prodInfo.Insert(ProdEntry(5, Statement, 1));
   _prodInfo.Insert(ProdEntry(4, Statement, 1));
   _prodInfo.Insert(ProdEntry(3, Statement, 0));
   _prodInfo.Insert(ProdEntry(2, StatementList, 2));
   _prodInfo.Insert(ProdEntry(1, StatementList, 3));
   _prodInfo.Insert(ProdEntry(0, Start, 1));
}

My2Cego::My2Cego()
{
   loadScanner();
   for ( int i=0; i < 103; i++)
   {
      int j;
      for ( j = 0; j < 43; j++)
         _actionMap[i][j] = ActionEntry();
      for ( j = 0; j < 28; j++)
         _jumpMap[i][j] = -1;
   }
   loadParser0();
   loadParser1();
   loadParser2();
   loadParser3();
   loadParser4();
   loadParser5();
   loadParser6();
   _isReserved = false;
}

My2Cego::~My2Cego()
{
}

void My2Cego::parse()
{
   StackT<StackEntry> s;
   StackEntry se(NONE, 0, 0);
   s.Push(se);
   _isReserved = false;
   if ( shiftToken() == false )
   {
      Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
      throw Exception(EXLOC, msg);
   }
   while ( true )
   {
      Action a;
      int num;
      if ( getAction(s.getTop()->getState(), _token, a, num) )
      {
         switch (a)
         {
            case SHIFT:
            {
               StackEntry se(TOKEN, _token, num, _tokenVal);
               s.Push(se);
               if ( shiftToken() == false )
               {
                  Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               break;
            }
            case REDUCE:
            {
               _tokenList.Empty();
               ProdEntry* pPE = _prodInfo.Find(num);
               for (int i=0; i<pPE->getNumSymbol();i++)
               {
                  StackEntry se;
                  s.Pop(se);
                  if (se.getSymbol() == TOKEN)
                     _tokenList.Insert(se.getTval());
               }
               int fstate;
               if (getJump(s.getTop()->getState(), pPE->getProd(), fstate))
               {
                  StackEntry se(PROD, pPE->getId(), fstate, _tokenVal);
                  s.Push(se);
               }
               else
               {
                  Chain msg = "Cannot reduce after token <" + Chain(_tokenVal) + ">.";
                  throw Exception(EXLOC, msg);
               }
               switch (num)
               {
                  case 52:
                     storeUnsignedType();
                     break;
                  case 51:
                     storeDim();
                     break;
                  case 50:
                     storeNullValue();
                     break;
                  case 49:
                     storeVarcharValue();
                     break;
                  case 48:
                     storeNegIntValue();
                     break;
                  case 47:
                     storeIntValue();
                     break;
                  case 44:
                     storeEnumType();
                     break;
                  case 43:
                     storeTimestampType();
                     break;
                  case 42:
                     storeVarcharType();
                     break;
                  case 41:
                     storeIntType();
                     break;
                  case 40:
                     storeTable();
                     break;
                  case 39:
                     insertConstValue();
                     break;
                  case 38:
                     insertConstValue();
                     break;
                  case 37:
                     execInsert();
                     break;
                  case 31:
                     storeKeyColumn();
                     break;
                  case 30:
                     storeKeyColumn();
                     break;
                  case 29:
                     storePrimaryKey();
                     break;
                  case 25:
                     storeDefaultNullOpt();
                     break;
                  case 24:
                     storeDefaultOpt();
                     break;
                  case 22:
                     storeNullOpt();
                     break;
                  case 21:
                     storeNotNullOpt();
                     break;
                  case 20:
                     storeNullOpt();
                     break;
                  case 19:
                     storeAttrColumn();
                     break;
                  case 10:
                     dropOpt2();
                     break;
                  case 9:
                     dropOpt1();
                     break;
                  case 8:
                     execDrop();
                     break;
                  case 7:
                     execCreate();
                     break;
               }
               break;
            }
            case ACCEPT:
            {
               postAction();
               return;
            }
            default:
               break;
         }
      }
      else
      {
         Chain msg = "Parse error at token <" + Chain(_tokenVal) + ">.";
         throw Exception(EXLOC, msg);
      }
   }
}


bool My2Cego::getAction(int state, My2Cego::Token token, My2Cego::Action& a, int& num)
{
    if (_actionMap[state][token].getAction() != NULLACTION )
    {
	a = _actionMap[state][token].getAction();
	num = _actionMap[state][token].getNum();
	return true;
    }
    else
    {
	return false;
    }
}

bool My2Cego::getJump(int state, Production prod, int& fstate)
{
    if ( _jumpMap[state][prod] > 0 )
    {
       fstate = _jumpMap[state][prod];
	    return true;
    }
    else
    {
	    return false;
    }
}

bool My2Cego::isSepSign(char c)
{
   if (c == ';') return true;
   if (c == ',') return true;
   if (c == '=') return true;
   if (c == '<') return true;
   if (c == '>') return true;
   if (c == ')') return true;
   if (c == '(') return true;
   if (c == '[') return true;
   if (c == ']') return true;
   if (c == '+') return true;
   if (c == '-') return true;
   if (c == '|') return true;
   return false;
}
bool My2Cego::isSepIgnore(char c)
{
   if (c == '\t') return true;
   if (c == ' ') return true;
   if (c == '\n') return true;
   return false;
}
bool My2Cego::shiftToken()
{
   unsigned long i=0;
   char c;
   while ( isSepIgnore(c = nextChar()) && ! _isReserved );
   if ( _isReserved )
   {
      _token = _reservedToken;
      _isReserved = false;
      return true;
   }
   if (c == 0)
   {
      _token = ENDTOKEN;
      return true;
   }
   if (isSepSign(c))
   {
      _tokenVal[i]=c;
       i++;
   }
   else
   {
      while (c && ! isSepIgnore(c) && ! ( isSepSign(c) && i>0 ) )
      {
         _tokenVal[i]=c;
         i++;
         c = nextChar();
      }
      if (isSepSign(c)) backChar();
   }
   _tokenVal[i]=0;
   Scanner* pS = _scannerList.First();
   while (pS)
   {
      if (pS->checkPattern(_tokenVal))
      {
         _token = pS->getToken();
         return true;
      }
      pS=_scannerList.Next();
   }
   return false;
}
void My2Cego::setReserved(Token t)
{
   _reservedToken = t;
   _isReserved = true;
}
